diff --git a/src/main/java/net/betterthanadventure/sound/SourceLWJGL3OpenAL.java b/src/main/java/net/betterthanadventure/sound/SourceLWJGL3OpenAL.java
new file mode 100644
index 000000000..ae034d971
--- /dev/null
+++ b/src/main/java/net/betterthanadventure/sound/SourceLWJGL3OpenAL.java
@@ -0,0 +1,435 @@
+package net.betterthanadventure.sound;
+
+import org.lwjgl.BufferUtils;
+import org.lwjgl.openal.AL10;
+import paulscode.sound.*;
+
+import javax.sound.sampled.AudioFormat;
+import java.nio.FloatBuffer;
+import java.nio.IntBuffer;
+import java.util.LinkedList;
+
+public class SourceLWJGL3OpenAL extends Source {
+    private ChannelLWJGL3OpenAL channelOpenAL;
+    private IntBuffer myBuffer;
+    private FloatBuffer listenerPosition;
+    private FloatBuffer sourcePosition;
+    private FloatBuffer sourceVelocity;
+
+    public SourceLWJGL3OpenAL(FloatBuffer var1, IntBuffer var2, boolean var3, boolean var4, boolean var5, String var6, FilenameURL var7, SoundBuffer var8, float var9, float var10, float var11, int var12, float var13, boolean var14) {
+        super(var3, var4, var5, var6, var7, var8, var9, var10, var11, var12, var13, var14);
+        this.channelOpenAL = (ChannelLWJGL3OpenAL)this.channel;
+        this.reverseByteOrder = true;
+        if (this.codec != null) {
+            this.codec.reverseByteOrder(true);
+        }
+
+        this.listenerPosition = var1;
+        this.myBuffer = var2;
+        this.libraryType = LibraryLWJGL3OpenAL.class;
+        this.pitch = 1.0F;
+        this.resetALInformation();
+    }
+
+    public SourceLWJGL3OpenAL(FloatBuffer var1, IntBuffer var2, Source var3, SoundBuffer var4) {
+        super(var3, var4);
+        this.channelOpenAL = (ChannelLWJGL3OpenAL)this.channel;
+        this.reverseByteOrder = true;
+        if (this.codec != null) {
+            this.codec.reverseByteOrder(true);
+        }
+
+        this.listenerPosition = var1;
+        this.myBuffer = var2;
+        this.libraryType = LibraryLWJGL3OpenAL.class;
+        this.pitch = 1.0F;
+        this.resetALInformation();
+    }
+
+    public SourceLWJGL3OpenAL(FloatBuffer var1, AudioFormat var2, boolean var3, String var4, float var5, float var6, float var7, int var8, float var9) {
+        super(var2, var3, var4, var5, var6, var7, var8, var9);
+        this.channelOpenAL = (ChannelLWJGL3OpenAL)this.channel;
+        this.reverseByteOrder = true;
+        this.listenerPosition = var1;
+        this.libraryType = LibraryLWJGL3OpenAL.class;
+        this.pitch = 1.0F;
+        this.resetALInformation();
+    }
+
+    public void cleanup() {
+        super.cleanup();
+    }
+
+    public void changeSource(FloatBuffer var1, IntBuffer var2, boolean var3, boolean var4, boolean var5, String var6, FilenameURL var7, SoundBuffer var8, float var9, float var10, float var11, int var12, float var13, boolean var14) {
+        super.changeSource(var3, var4, var5, var6, var7, var8, var9, var10, var11, var12, var13, var14);
+        this.reverseByteOrder = true;
+        this.listenerPosition = var1;
+        this.myBuffer = var2;
+        this.pitch = 1.0F;
+        this.resetALInformation();
+    }
+
+    public boolean incrementSoundSequence() {
+        if (!this.toStream) {
+            this.errorMessage("Method 'incrementSoundSequence' may only be used for streaming sources.");
+            return false;
+        } else {
+            synchronized(this.soundSequenceLock) {
+                if (this.soundSequenceQueue != null && this.soundSequenceQueue.size() > 0) {
+                    this.filenameURL = (FilenameURL)this.soundSequenceQueue.remove(0);
+                    if (this.codec != null) {
+                        this.codec.cleanup();
+                    }
+
+                    this.codec = SoundSystemConfig.getCodec(this.filenameURL.getFilename());
+                    if (this.codec != null) {
+                        this.codec.reverseByteOrder(true);
+                        if (this.codec.getAudioFormat() == null) {
+                            this.codec.initialize(this.filenameURL.getURL());
+                        }
+
+                        AudioFormat var2 = this.codec.getAudioFormat();
+                        if (var2 == null) {
+                            this.errorMessage("Audio Format null in method 'incrementSoundSequence'");
+                            return false;
+                        }
+
+                        boolean var3 = false;
+                        short var6;
+                        if (var2.getChannels() == 1) {
+                            if (var2.getSampleSizeInBits() == 8) {
+                                var6 = 4352;
+                            } else {
+                                if (var2.getSampleSizeInBits() != 16) {
+                                    this.errorMessage("Illegal sample size in method 'incrementSoundSequence'");
+                                    return false;
+                                }
+
+                                var6 = 4353;
+                            }
+                        } else {
+                            if (var2.getChannels() != 2) {
+                                this.errorMessage("Audio data neither mono nor stereo in method 'incrementSoundSequence'");
+                                return false;
+                            }
+
+                            if (var2.getSampleSizeInBits() == 8) {
+                                var6 = 4354;
+                            } else {
+                                if (var2.getSampleSizeInBits() != 16) {
+                                    this.errorMessage("Illegal sample size in method 'incrementSoundSequence'");
+                                    return false;
+                                }
+
+                                var6 = 4355;
+                            }
+                        }
+
+                        this.channelOpenAL.setFormat(var6, (int)var2.getSampleRate());
+                        this.preLoad = true;
+                    }
+
+                    return true;
+                } else {
+                    return false;
+                }
+            }
+        }
+    }
+
+    public void listenerMoved() {
+        this.positionChanged();
+    }
+
+    public void setPosition(float var1, float var2, float var3) {
+        super.setPosition(var1, var2, var3);
+        if (this.sourcePosition == null) {
+            this.resetALInformation();
+        } else {
+            this.positionChanged();
+        }
+
+        this.sourcePosition.put(0, var1);
+        this.sourcePosition.put(1, var2);
+        this.sourcePosition.put(2, var3);
+        if (this.channel != null && this.channel.attachedSource == this && this.channelOpenAL != null && this.channelOpenAL.ALSource != null) {
+            AL10.alSourcefv(this.channelOpenAL.ALSource.get(0), 4100, this.sourcePosition);
+            this.checkALError();
+        }
+
+    }
+
+    public void positionChanged() {
+        this.calculateDistance();
+        this.calculateGain();
+        if (this.channel != null && this.channel.attachedSource == this && this.channelOpenAL != null && this.channelOpenAL.ALSource != null) {
+            AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4106, this.gain * this.sourceVolume * Math.abs(this.fadeOutGain) * this.fadeInGain);
+            this.checkALError();
+        }
+
+        this.checkPitch();
+    }
+
+    private void checkPitch() {
+        if (this.channel != null && this.channel.attachedSource == this && LibraryLWJGL3OpenAL.alPitchSupported() && this.channelOpenAL != null && this.channelOpenAL.ALSource != null) {
+            AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4099, this.pitch);
+            this.checkALError();
+        }
+
+    }
+
+    public void setLooping(boolean var1) {
+        super.setLooping(var1);
+        if (this.channel != null && this.channel.attachedSource == this && this.channelOpenAL != null && this.channelOpenAL.ALSource != null) {
+            if (var1) {
+                AL10.alSourcei(this.channelOpenAL.ALSource.get(0), 4103, 1);
+            } else {
+                AL10.alSourcei(this.channelOpenAL.ALSource.get(0), 4103, 0);
+            }
+
+            this.checkALError();
+        }
+
+    }
+
+    public void setAttenuation(int var1) {
+        super.setAttenuation(var1);
+        if (this.channel != null && this.channel.attachedSource == this && this.channelOpenAL != null && this.channelOpenAL.ALSource != null) {
+            if (var1 == 1) {
+                AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4129, this.distOrRoll);
+            } else {
+                AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4129, 0.0F);
+            }
+
+            this.checkALError();
+        }
+
+    }
+
+    public void setDistOrRoll(float var1) {
+        super.setDistOrRoll(var1);
+        if (this.channel != null && this.channel.attachedSource == this && this.channelOpenAL != null && this.channelOpenAL.ALSource != null) {
+            if (this.attModel == 1) {
+                AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4129, var1);
+            } else {
+                AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4129, 0.0F);
+            }
+
+            this.checkALError();
+        }
+
+    }
+
+    public void setPitch(float var1) {
+        super.setPitch(var1);
+        this.checkPitch();
+    }
+
+    public void play(Channel var1) {
+        if (!this.active()) {
+            if (this.toLoop) {
+                this.toPlay = true;
+            }
+
+        } else if (var1 == null) {
+            this.errorMessage("Unable to play source, because channel was null");
+        } else {
+            boolean var2 = this.channel != var1;
+            if (this.channel != null && this.channel.attachedSource != this) {
+                var2 = true;
+            }
+
+            boolean var3 = this.paused();
+            super.play(var1);
+            this.channelOpenAL = (ChannelLWJGL3OpenAL)this.channel;
+            if (var2) {
+                this.setPosition(this.position.x, this.position.y, this.position.z);
+                this.checkPitch();
+                if (this.channelOpenAL != null && this.channelOpenAL.ALSource != null) {
+                    if (LibraryLWJGL3OpenAL.alPitchSupported()) {
+                        AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4099, this.pitch);
+                        this.checkALError();
+                    }
+
+                    AL10.alSourcefv(this.channelOpenAL.ALSource.get(0), 4100, this.sourcePosition);
+                    this.checkALError();
+                    AL10.alSourcefv(this.channelOpenAL.ALSource.get(0), 4102, this.sourceVelocity);
+                    this.checkALError();
+                    if (this.attModel == 1) {
+                        AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4129, this.distOrRoll);
+                    } else {
+                        AL10.alSourcef(this.channelOpenAL.ALSource.get(0), 4129, 0.0F);
+                    }
+
+                    this.checkALError();
+                    if (this.toLoop && !this.toStream) {
+                        AL10.alSourcei(this.channelOpenAL.ALSource.get(0), 4103, 1);
+                    } else {
+                        AL10.alSourcei(this.channelOpenAL.ALSource.get(0), 4103, 0);
+                    }
+
+                    this.checkALError();
+                }
+
+                if (!this.toStream) {
+                    if (this.myBuffer == null) {
+                        this.errorMessage("No sound buffer to play");
+                        return;
+                    }
+
+                    this.channelOpenAL.attachBuffer(this.myBuffer);
+                }
+            }
+
+            if (!this.playing()) {
+                if (this.toStream && !var3) {
+                    if (this.codec == null) {
+                        this.errorMessage("Decoder null in method 'play'");
+                        return;
+                    }
+
+                    if (this.codec.getAudioFormat() == null) {
+                        this.codec.initialize(this.filenameURL.getURL());
+                    }
+
+                    AudioFormat var4 = this.codec.getAudioFormat();
+                    if (var4 == null) {
+                        this.errorMessage("Audio Format null in method 'play'");
+                        return;
+                    }
+
+                    boolean var5 = false;
+                    short var6;
+                    if (var4.getChannels() == 1) {
+                        if (var4.getSampleSizeInBits() == 8) {
+                            var6 = 4352;
+                        } else {
+                            if (var4.getSampleSizeInBits() != 16) {
+                                this.errorMessage("Illegal sample size in method 'play'");
+                                return;
+                            }
+
+                            var6 = 4353;
+                        }
+                    } else {
+                        if (var4.getChannels() != 2) {
+                            this.errorMessage("Audio data neither mono nor stereo in method 'play'");
+                            return;
+                        }
+
+                        if (var4.getSampleSizeInBits() == 8) {
+                            var6 = 4354;
+                        } else {
+                            if (var4.getSampleSizeInBits() != 16) {
+                                this.errorMessage("Illegal sample size in method 'play'");
+                                return;
+                            }
+
+                            var6 = 4355;
+                        }
+                    }
+
+                    this.channelOpenAL.setFormat(var6, (int)var4.getSampleRate());
+                    this.preLoad = true;
+                }
+
+                this.channel.play();
+                if (this.pitch != 1.0F) {
+                    this.checkPitch();
+                }
+            }
+
+        }
+    }
+
+    public boolean preLoad() {
+        if (this.codec == null) {
+            return false;
+        } else {
+            this.codec.initialize(this.filenameURL.getURL());
+            LinkedList var1 = new LinkedList();
+
+            for(int var2 = 0; var2 < SoundSystemConfig.getNumberStreamingBuffers(); ++var2) {
+                this.soundBuffer = this.codec.read();
+                if (this.soundBuffer == null || this.soundBuffer.audioData == null) {
+                    break;
+                }
+
+                var1.add(this.soundBuffer.audioData);
+            }
+
+            this.positionChanged();
+            this.channel.preLoadBuffers(var1);
+            this.preLoad = false;
+            return true;
+        }
+    }
+
+    private void resetALInformation() {
+        this.sourcePosition = BufferUtils.createFloatBuffer(3).put(new float[]{this.position.x, this.position.y, this.position.z});
+        this.sourceVelocity = BufferUtils.createFloatBuffer(3).put(new float[]{0.0F, 0.0F, 0.0F});
+        this.sourcePosition.flip();
+        this.sourceVelocity.flip();
+        this.positionChanged();
+    }
+
+    private void calculateDistance() {
+        if (this.listenerPosition != null) {
+            double var1 = (double)(this.position.x - this.listenerPosition.get(0));
+            double var3 = (double)(this.position.y - this.listenerPosition.get(1));
+            double var5 = (double)(this.position.z - this.listenerPosition.get(2));
+            this.distanceFromListener = (float)Math.sqrt(var1 * var1 + var3 * var3 + var5 * var5);
+        }
+
+    }
+
+    private void calculateGain() {
+        if (this.attModel == 2) {
+            if (this.distanceFromListener <= 0.0F) {
+                this.gain = 1.0F;
+            } else if (this.distanceFromListener >= this.distOrRoll) {
+                this.gain = 0.0F;
+            } else {
+                this.gain = 1.0F - this.distanceFromListener / this.distOrRoll;
+            }
+
+            if (this.gain > 1.0F) {
+                this.gain = 1.0F;
+            }
+
+            if (this.gain < 0.0F) {
+                this.gain = 0.0F;
+            }
+        } else {
+            this.gain = 1.0F;
+        }
+
+    }
+
+    private boolean checkALError() {
+        switch( AL10.alGetError() )
+        {
+            case AL10.AL_NO_ERROR:
+                return false;
+            case AL10.AL_INVALID_NAME:
+                errorMessage( "Invalid name parameter." );
+                return true;
+            case AL10.AL_INVALID_ENUM:
+                errorMessage( "Invalid parameter." );
+                return true;
+            case AL10.AL_INVALID_VALUE:
+                errorMessage( "Invalid enumerated parameter value." );
+                return true;
+            case AL10.AL_INVALID_OPERATION:
+                errorMessage( "Illegal call." );
+                return true;
+            case AL10.AL_OUT_OF_MEMORY:
+                errorMessage( "Unable to allocate memory." );
+                return true;
+            default:
+                errorMessage( "An unrecognized error occurred." );
+                return true;
+        }
+    }
+
+}
diff --git a/src/main/java/net/betterthanadventure/utils/ColorizerGenerator.java b/src/main/java/net/betterthanadventure/utils/ColorizerGenerator.java
index d2c6d8583..6eda87c4a 100644
--- a/src/main/java/net/betterthanadventure/utils/ColorizerGenerator.java
+++ b/src/main/java/net/betterthanadventure/utils/ColorizerGenerator.java
@@ -2,6 +2,8 @@ package net.betterthanadventure.utils;
 import net.minecraft.core.util.helper.Color;
 import org.lwjgl.opengl.Display;
 import org.lwjgl.opengl.DisplayMode;
+import org.lwjgl.opengl.PixelFormat;
+
 import static org.lwjgl.opengl.GL11.*;
 
 public class ColorizerGenerator {
@@ -47,7 +49,7 @@ public class ColorizerGenerator {
     public static void main(String[] args) throws Exception {
         Display.setDisplayMode(new DisplayMode(257, 257));
         Display.setTitle("Gradient");
-        Display.create();
+        Display.create(new PixelFormat());
         Display.setVSyncEnabled(true);
 
 
diff --git a/src/main/java/net/betterthanadventure/utils/DataDumper.java b/src/main/java/net/betterthanadventure/utils/DataDumper.java
index 28b51e18d..0092b83f9 100644
--- a/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -4,17 +4,19 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.tag.ITaggable;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.entity.SpawnListEntry;
-import net.minecraft.core.enums.EnumCreatureType;
+import net.minecraft.core.enums.MobCategory;
+import net.minecraft.core.item.FoodItem;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemFood;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.tag.ItemTags;
-import net.minecraft.core.item.tool.ItemToolPickaxe;
+import net.minecraft.core.item.tool.PickaxeToolItem;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
@@ -61,8 +63,8 @@ public class DataDumper implements MinecraftAccessor {
         I18n.initialize("en_US");
         translator = I18n.getInstance();
 
-        System.out.println(Block.dirt.id);
-        System.out.println(Item.stick.id);
+        System.out.println(Blocks.DIRT.id);
+        System.out.println(Items.STICK.id);
 
         File wikiDumpFile = new File(getMinecraftDir(), "infodump");
         wikiDumpFile.mkdirs();
@@ -111,7 +113,7 @@ public class DataDumper implements MinecraftAccessor {
                 .append(item.id).append(",")
                 .append(item.getKey()).append(",")
                 .append(item.getMaxDamage()).append(",")
-                .append(item instanceof ItemFood ? ((ItemFood) item).getHealAmount() : "").append(",")
+                .append(item instanceof FoodItem ? ((FoodItem) item).getHealAmount() : "").append(",")
                 .append(item.getItemStackLimit()).append(",")
                 .append("\"").append(translator.translateNameKey(item.getKey())).append("\"").append(",")
                 .append("\"").append(translator.translateDescKey(item.getKey())).append("\"").append(",");
@@ -127,7 +129,7 @@ public class DataDumper implements MinecraftAccessor {
                 .append(block.getKey()).append(",")
                 .append(block.getHardness()).append(",")
                 .append(block.getBlastResistance(null)).append(",")
-                .append(ItemToolPickaxe.miningLevels.getOrDefault(block, 0)).append(",")
+                .append(PickaxeToolItem.miningLevels.getOrDefault(block, 0)).append(",")
                 .append(block.asItem().getItemStackLimit()).append(",")
                 .append("\"").append(translator.translateNameKey(block.getKey())).append("\"").append(",")
                 .append("\"").append(translator.translateDescKey(block.getKey())).append("\"").append(",");
@@ -159,10 +161,10 @@ public class DataDumper implements MinecraftAccessor {
 
         builder.append(s).append("\",");
 
-        builder.append("\"").append(spawnableListString(biome.getSpawnableList(EnumCreatureType.monster))).append("\",");
-        builder.append("\"").append(spawnableListString(biome.getSpawnableList(EnumCreatureType.creature))).append("\",");
-        builder.append("\"").append(spawnableListString(biome.getSpawnableList(EnumCreatureType.waterCreature))).append("\",");
-        builder.append("\"").append(spawnableListString(biome.getSpawnableList(EnumCreatureType.ambientCreature))).append("\"");
+        builder.append("\"").append(spawnableListString(biome.getSpawnableList(MobCategory.monster))).append("\",");
+        builder.append("\"").append(spawnableListString(biome.getSpawnableList(MobCategory.creature))).append("\",");
+        builder.append("\"").append(spawnableListString(biome.getSpawnableList(MobCategory.waterCreature))).append("\",");
+        builder.append("\"").append(spawnableListString(biome.getSpawnableList(MobCategory.ambientCreature))).append("\"");
         builder.append("\n");
 
         return builder.toString();
